CREATE PROCEDURE dbo.FindOrders_UsingJSON_Broken
  @List VARCHAR(MAX)
AS
BEGIN
  SET NOCOUNT ON;

  SELECT SalesOrderID FROM Sales.SalesOrderHeaderEnlarged
    WHERE SalesOrderID IN (@List);
END
GO

DECLARE @List VARCHAR(MAX) = '330227,273691,1003613,1150729,1130412,414097'
  + ',957188,256658,869880,1297400,102222,693262,146300,1223569,71026'
  + ',1161693,1237396,134616,741849,647783';

EXEC dbo.FindOrders_UsingJSON_Broken @List;
GO

CREATE FUNCTION dbo.SplitJSONInts(@List VARCHAR(MAX))
RETURNS TABLE
WITH SCHEMABINDING
AS
   RETURN ( SELECT Item FROM ( SELECT Item = x.i.value('(./text())[1]', 'int') FROM 
            ( SELECT [XML] = CONVERT(XML, '<i>' + REPLACE(@List, ',', '</i><i>') 
              + '</i>').query('.') ) AS a CROSS APPLY [XML].nodes('i') AS x(i)
          ) AS y WHERE Item IS NOT NULL
   );
GO

CREATE PROCEDURE dbo.FindOrders_UsingJSON_FixedKindOf
  @List VARCHAR(MAX)
AS
BEGIN
  SET NOCOUNT ON;

  SELECT SalesOrderID FROM Sales.SalesOrderHeaderEnlarged AS h
    WHERE EXISTS 
	(
	  SELECT 1 FROM dbo.SplitJSONInts(@List) AS l
	  WHERE l.Item = h.SalesOrderID
	);
END
GO

CREATE TYPE dbo.Integers AS TABLE(Item INT PRIMARY KEY);
GO

CREATE PROCEDURE dbo.FindOrders_UsingTVP
  @List dbo.Integers READONLY
AS
BEGIN
  SET NOCOUNT ON;

  SELECT SalesOrderID FROM Sales.SalesOrderHeaderEnlarged AS h
    WHERE EXISTS (SELECT 1 FROM @List WHERE Item = h.SalesOrderID);
END
GO